<?php
/**
Plugin Name: ShushThatNoise - Ignorant Comment Hider
Plugin URI: http://wordpress.org/extend/plugins/shushthatnoise/
Description: Hide unwanted comments without deleting them. Edit the comment and wrap the offending text in <strong>[shush][/shush]</strong>. (Example: [shush]FIRST!!![/shush]) Readers can choose to read the hidden comment by clicking on the "Show" link. <em>Bonus:</em> You can also use this shortcode in your posts as a "Spoiler" hider.
Author: Zing-Ming
Version: 1.0
*/

class ShushThatNoise {
      const shortcodeName = "shush";

      function ShushThatNoise () {
      	       add_shortcode(self::shortcodeName, array($this, 'runShortcode'));
	       add_filter('comment_text', array($this, 'filterComment'));
      }

      function runShortcode ($atts = null, $content = null) {
	       return $this->getOpeningHtmlTags(true) . $content . $this->getClosingHtmlTags();
      }

      function filterComment ($comment) {
      	       $shortcodeOpening = '/\[' . self::shortcodeName . '\]/';
	       $shortcodeClosing = '/\[\/' . self::shortcodeName . '\]/';
      	       $shushed = preg_replace($shortcodeOpening, $this->getOpeningHtmlTags(), $comment); 
      	       $shushed = preg_replace($shortcodeClosing, $this->getClosingHtmlTags(), $shushed);    	       
	       return $shushed;
      }

      function getOpeningHtmlTags ($byAuthor = false) {
      	       return "<div>\n" . $this->getNote($byAuthor) . '<a href="javascript:;" onclick="' . $this->getJS() . '">Show</a>' . "\n" . '<div style="display:none;">';
      }

      function getClosingHtmlTags () {
      	      return "</div>\n</div>\n";
      }

      function getJS () {
      	       return "var noise = this.parentNode.getElementsByTagName('div')[0]; if (noise.style.display == 'none') { noise.style.display = ''; this.innerHTML = 'Hide';} else { noise.style.display = 'none'; this.innerHTML = 'Show'; }";
      }

      function getNote ($byAuthor = false) {
       	       if ($byAuthor)
	       {
			return "<em>Spoiler</em>: ";
	       }
	       else
	       {	
      	       		return "<em>Buried Comment:</em> ";
	       }
      }
}

$shushthatnoise = new ShushThatNoise();

?>
